import { RouteService, PageRoute } from "../../route";
import { ExpressService } from "../expressService";
export declare class DefaultPageService extends RouteService {
    readonly name: string;
    readonly prefix: string;
    dependencies: (string | RegExp)[];
    services: {
        ExpressService: ExpressService;
    };
    initialize(): void;
    constructor(option?: {
        page?: {
            default?: string;
        };
    });
    defaultPagePath: string;
    defaultPageCode: number;
    defaultHTML: string;
    clearDefaultHTMLCache(): void;
    protected generateDefaultHTMLContent(callback: (err, html?: string) => void): void;
    getDefaultPage(callback: (err, html?: string) => void): void;
    setDefaultHTMLContent(html: string): void;
}
export declare class DefaultPage extends PageRoute {
    readonly path: string;
    service: DefaultPageService;
    handle(): void;
}
