"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
var ConnectMongo = require("connect-mongo");
var ExpressSession = require("express-session");
var MongoStore = ConnectMongo(ExpressSession);
var RouteSessionService = (function (_super) {
    __extends(RouteSessionService, _super);
    function RouteSessionService(config) {
        if (config === void 0) { config = {}; }
        var _this = _super.call(this) || this;
        _this.name = "RouteSessionService";
        _this.dependencies = ["ExpressService", "MongodbService"];
        _this.config = {};
        _this.defaultSecret = "default-session-secret";
        // 31 day
        _this.defaultMaxAge = 1000 * 60 * 60 * 24 * 31;
        var http = config.http || {};
        _this.config = http.session || {};
        return _this;
    }
    RouteSessionService.prototype.asBuiltIn = function () {
        console.log("RouteService default use MongodbService and default secret: " + (this.config.secret || this.defaultSecret));
    };
    RouteSessionService.prototype.initialize = function () {
        this.services.ExpressService.server.use(ExpressSession({
            secret: this.config.secret || this.defaultSecret,
            store: this.config.store || new MongoStore({ db: this.services.MongodbService.db, ttl: this.config.maxAge || this.defaultMaxAge }),
            resave: this.config.resave || false,
            saveUninitialized: this.config.saveUninitialized || false
        }));
    };
    return RouteSessionService;
}(service_1.Service));
exports.RouteSessionService = RouteSessionService;
//# sourceMappingURL=routeSessionService.js.map