import { Service } from "../service";
import * as Leaf from "leaf-ts";
export declare const Errors: Leaf.ErrorsOf<{
    InvalidUsername: {};
    UsernameTooShort: {};
    UsernameTooLong: {};
    PasswordTooShort: {};
    PasswordTooLong: {};
    EmailTooLong: {};
    InvalidEmail: {};
    InvalidDisplayName: {};
    DisplayNameTooShort: {};
    DisplayNameTooLong: {};
    InvalidPassword: {};
    UsernameRequired: {};
    PasswordRequired: {};
    EmailRequired: {};
}>;
export declare type User = UserDefinitionService.User;
export declare class UserDefinitionService<TUser extends UserDefinitionService.User> extends Service {
    readonly name: string;
    UserPartialValidator: Leaf.Validator;
    UserValidator: Leaf.Validator<{
        [key: string]: any;
    }>;
}
export declare namespace UserDefinitionService {
    interface User {
        id?: string;
        username: string;
        displayName?: string;
        passwordHash?: string;
        password?: string;
        email: string;
        createAt?: number;
    }
}
export interface UserValidationConfig {
    minUsernameLength: number;
    maxUsernameLength: number;
    minDisplayNameLength: number;
    maxDisplayNameLength: number;
    minPasswordLength: number;
    maxPasswordLength: number;
    maxEmailLength: number;
}
export declare const DefaultUserValidationConfig: UserValidationConfig;
export declare function GenerateUserValidator(config?: UserValidationConfig): Leaf.Validator<{
    [key: string]: any;
}>;
